package me.wazup.hideandseek.managers;

import org.bukkit.Bukkit;
import java.io.InputStream;
import java.io.IOException;
import org.bukkit.configuration.Configuration;
import java.io.Reader;
import java.io.InputStreamReader;
import org.bukkit.configuration.file.YamlConfiguration;
import java.io.File;
import java.util.Iterator;
import me.wazup.hideandseek.HideAndSeek;
import org.bukkit.configuration.file.FileConfiguration;
import java.util.HashMap;

public class FilesManager
{
    private static FilesManager instance;
    private final HashMap<String, FileConfiguration> configurations;
    
    public FilesManager() {
        this.configurations = new HashMap<String, FileConfiguration>();
        FilesManager.instance = this;
        HideAndSeek.getInstance().reloadConfig();
        HideAndSeek.getInstance().getConfig().options().copyDefaults(true);
        HideAndSeek.getInstance().saveConfig();
        this.registerConfig("arenas.yml");
        this.registerConfig("items.yml");
        this.registerConfig("players.yml");
        this.registerConfig("ranks.yml");
        this.registerConfig("signs.yml");
        this.registerConfig("messages.yml");
        this.registerConfig("powerups.yml");
        this.registerConfig("trails_blacklist.yml");
        this.registerConfig("achievements.yml");
        for (final String key : this.configurations.keySet()) {
            this.reloadConfig(key);
            this.configurations.get(key).options().copyDefaults(true);
            this.saveConfig(key);
        }
    }
    
    public static FilesManager getInstance() {
        return FilesManager.instance;
    }
    
    private void registerConfig(final String s) {
        this.configurations.put(s, (FileConfiguration)YamlConfiguration.loadConfiguration(new File(HideAndSeek.getInstance().getDataFolder(), s)));
    }
    
    public FileConfiguration getConfig(final String key) {
        return this.configurations.get(key);
    }
    
    private void reloadConfig(final String key) {
        final InputStream resource = HideAndSeek.getInstance().getResource(key);
        if (resource != null) {
            final InputStreamReader inputStreamReader = new InputStreamReader(resource);
            this.configurations.get(key).setDefaults((Configuration)YamlConfiguration.loadConfiguration((Reader)inputStreamReader));
            try {
                inputStreamReader.close();
                resource.close();
            }
            catch (final IOException ex) {
                ex.printStackTrace();
            }
        }
    }
    
    public void saveConfig(final String str) {
        try {
            this.configurations.get(str).save(new File(HideAndSeek.getInstance().getDataFolder(), str));
        }
        catch (final IOException ex) {
            Bukkit.getConsoleSender().sendMessage("[HideAndSeek] Couldn't save " + str + "!");
        }
    }
}
